//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_LIBRARY_UI_MODIFY_ALBUMS_HH 
#define BMP_LIBRARY_UI_MODIFY_ALBUMS_HH

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glibmm.h>
#include <glibmm/markup.h>
#include <gtkmm.h>
#include <libglademm.h>

#include "amazon.hh"
#include "mbxml.hh"
#include "library.hh"

namespace Bmp
{
  class LibraryUIModifyImport
    : public Gtk::Dialog
  {
    public:

        LibraryUIModifyImport (BaseObjectType                       *cobject,
                  const Glib::RefPtr<Gnome::Glade::Xml> &xml);

        static LibraryUIModifyImport*
        create ();

        virtual int
        run (const MusicBrainzXML::MBReleaseV& releases);

        virtual int
        rerun ();

        // The release chosen last
        MusicBrainzXML::MBRelease selected;

    private:

      void
      artist_changed	();

      void
      album_changed	();

      void
      on_button_update	();

      void
      populate_store (MusicBrainzXML::MBReleaseV& releases);
	
      // ColumnRecords
      class ColumnRecordArtist
        : public Gtk::TreeModel::ColumnRecord
      {
        public:

          Gtk::TreeModelColumn<Glib::ustring> name;
          Gtk::TreeModelColumn<Glib::ustring> id; 

          ColumnRecordArtist ()
          {
            add (name);
            add (id);
          }
      };
      ColumnRecordArtist artists;

      class ColumnRecordAlbum
        : public Gtk::TreeModel::ColumnRecord
      {
        public:

          Gtk::TreeModelColumn<Glib::ustring> name;
          Gtk::TreeModelColumn<Glib::ustring>   id; // Release ID

          ColumnRecordAlbum ()
          {
            add (name);
            add (id);
          }
      };
      ColumnRecordAlbum albums;


      typedef std::map < Glib::ustring, MusicBrainzXML::MBRelease > ReleaseMap;
      ReleaseMap merge_releases;

      typedef std::vector < Glib::ustring > ReleaseIds;
      typedef std::map < Glib::ustring, ReleaseIds > ArtistReleaseMap; 
      ArtistReleaseMap  merge_artist_release_map;

      // GladeXML+Widgets
      Glib::RefPtr<Gnome::Glade::Xml> ref_xml;

      Gtk::ComboBoxEntry	    *merge_cb_artist;
      Gtk::ComboBoxEntry	    *merge_cb_album;

      Gtk::Entry		    *merge_cb_artist_entry;
      Gtk::Entry		    *merge_cb_album_entry;


      Glib::RefPtr<Gtk::ListStore>   merge_cb_artist_store;
      Glib::RefPtr<Gtk::ListStore>   merge_cb_album_store;

      Gtk::Image		                *merge_coverart;
      Glib::RefPtr<Gdk::Pixbuf>	     disc;

      Gtk::Entry		    *merge_album;
      Gtk::Entry		    *merge_artist;
      Gtk::Entry		    *merge_artist_id;
      Gtk::Entry		    *merge_asin;
      Gtk::Entry		    *merge_release_id;
      Gtk::Entry		    *merge_score;

      Gtk::Label		    *l_tracks;
      Gtk::Button		    *b_refresh;
      Gtk::Button		    *ok;
      Gtk::Button		    *cancel;
  };
}
#endif
