//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_LIBRARY_UI_MOVE_ALBUM_HPP 
#define BMP_LIBRARY_UI_MOVE_ALBUM_HPP

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glibmm.h>
#include <glibmm/markup.h>
#include <gtkmm.h>
#include <libglademm.h>

#include "amazon.hh"
#include "library.hh"
#include "mbxml.hh"

namespace Bmp
{
  class LibraryUIRelocateAlbum
    : public Gtk::Dialog
  {
    public:

      LibraryUIRelocateAlbum (BaseObjectType                       *cobject,
                          const Glib::RefPtr<Gnome::Glade::Xml> &xml);

      ~LibraryUIRelocateAlbum ();

      static LibraryUIRelocateAlbum*
      create ();

      int
      run (Library::Album const& album);

      Gtk::FileChooserButton *fcb_move;
      Bmp::DB::RowV           vector;
      Gtk::CheckButton	     *cb_append_albumname;

    private:

      void
      fcb_current_folder_changed ();

      // GladeXML+Widgets
      Glib::RefPtr<Gnome::Glade::Xml> ref_xml;

      Gtk::Image		                *coverart;
      Glib::RefPtr<Gdk::Pixbuf>	     disc;

      Gtk::Entry		                *e_album;
      Gtk::Entry		                *e_artist;

      Gtk::HBox                     *hbox_warning;
      Gtk::Button                   *okbutton2;
  };
}
#endif
