// (c) 2005 Martin Aumueller <aumuell@reserv.at>
// See COPYING file for licensing information

#include "taglib_mp4filetyperesolver.h"
#include "mp4file.h"

#include <src/util.hh> 
#include <src/audio.hh>

TagLib::File *MP4FileTypeResolver::createFile (const char*                        filename,
                                               bool                               read_properties,
                                               TagLib::AudioProperties::ReadStyle properties_style) const
{
    std::string type;
    if (!Bmp::Audio::typefind (filename, type)) return 0;

    if (type == "audio/x-m4a")
      {
        MP4FileHandle h = MP4Modify (filename, 0);
        if (MP4_INVALID_FILE_HANDLE == h)
          {
            return 0;
          }
        return new TagLib::MP4::File(filename, read_properties, properties_style, h);
      }

    return 0;
}
